#include <kapp.h>
#include "granteditdata.h"

#define Inherited QDialog

#ifndef rcsid
static const char rcsid[]="$Id: granteditdata.cpp,v 2.2 1999/07/04 22:30:46 ral Exp $";
const char*granteditdata_rcs(){return rcsid;}
#endif

#include <qlayout.h>

CGrantEditData::CGrantEditData(	QWidget* parent,const char* name)
    :Inherited( parent, name, TRUE, 0 )
{
    SaveButton = new QPushButton( this, "SaveButton" );
    SaveButton->setGeometry( 0, 0, 133, 25 );
    SaveButton->setMinimumSize( 10, 25 );
    SaveButton->setMaximumSize( 32767, 25 );
    connect( SaveButton, SIGNAL(clicked()), SLOT(accept()) );
    SaveButton->setText( i18n("Save") );
    SaveButton->setAutoRepeat( FALSE );
    SaveButton->setAutoResize( FALSE );

    ResetButton = new QPushButton( this, "ResetButton" );
    ResetButton->setGeometry( 133, 0, 134, 25 );
    ResetButton->setMinimumSize( 10, 25 );
    ResetButton->setMaximumSize( 32767, 25 );
    connect( ResetButton, SIGNAL(clicked()), SLOT(reset_values()) );
    ResetButton->setText( i18n("Reset") );
    ResetButton->setAutoRepeat( FALSE );
    ResetButton->setAutoResize( FALSE );

    CloseButton = new QPushButton( this, "CloseButton" );
    CloseButton->setGeometry( 267, 0, 133, 25 );
    CloseButton->setMinimumSize( 10, 25 );
    CloseButton->setMaximumSize( 32767, 25 );
    connect( CloseButton, SIGNAL(clicked()), SLOT(reject()) );
    CloseButton->setText( i18n("Close") );
    CloseButton->setAutoRepeat( FALSE );
    CloseButton->setAutoResize( FALSE );

    SelectBox = new QCheckBox( this, "SelelectBox" );
    SelectBox->setGeometry( 0, 0, 80, 25 );
    SelectBox->setMinimumSize( 10, 25 );
    SelectBox->setMaximumSize( 32767, 25 );
    connect( SelectBox, SIGNAL(toggled(bool)), SLOT(SelectToggled(bool)) );
    SelectBox->setText( i18n("Select") );
    SelectBox->setAutoRepeat( FALSE );
    SelectBox->setAutoResize( FALSE );

    InsertBox = new QCheckBox( this, "InsertBox" );
    InsertBox->setGeometry( 80, 0, 80, 25 );
    InsertBox->setMinimumSize( 10, 25 );
    InsertBox->setMaximumSize( 32767, 25 );
    connect( InsertBox, SIGNAL(toggled(bool)), SLOT(InsertToggled(bool)) );
    InsertBox->setText( i18n("Insert") );
    InsertBox->setAutoRepeat( FALSE );
    InsertBox->setAutoResize( FALSE );

    UpdateBox = new QCheckBox( this, "UpdateBox" );
    UpdateBox->setGeometry( 160, 0, 80, 25 );
    UpdateBox->setMinimumSize( 10, 25 );
    UpdateBox->setMaximumSize( 32767, 25 );
    connect( UpdateBox, SIGNAL(toggled(bool)), SLOT(UpdateToggled(bool)) );
    UpdateBox->setText( i18n("Update") );
    UpdateBox->setAutoRepeat( FALSE );
    UpdateBox->setAutoResize( FALSE );

    DeleteBox = new QCheckBox( this, "DeleteBox" );
    DeleteBox->setGeometry( 240, 0, 80, 25 );
    DeleteBox->setMinimumSize( 10, 25 );
    DeleteBox->setMaximumSize( 32767, 25 );
    connect( DeleteBox, SIGNAL(toggled(bool)), SLOT(DeleteToggled(bool)) );
    DeleteBox->setText( i18n("Delete") );
    DeleteBox->setAutoRepeat( FALSE );
    DeleteBox->setAutoResize( FALSE );

    CreateBox = new QCheckBox( this, "CreateBox" );
    CreateBox->setGeometry( 320, 0, 80, 25 );
    CreateBox->setMinimumSize( 10, 25 );
    CreateBox->setMaximumSize( 32767, 25 );
    connect( CreateBox, SIGNAL(toggled(bool)), SLOT(CreateToggled(bool)) );
    CreateBox->setText( i18n("Create") );
    CreateBox->setAutoRepeat( FALSE );
    CreateBox->setAutoResize( FALSE );

    DropBox = new QCheckBox( this, "DropBox" );
    DropBox->setGeometry( 0, 0, 80, 25 );
    DropBox->setMinimumSize( 10, 25 );
    DropBox->setMaximumSize( 32767, 25 );
    DropBox->setText( i18n("Drop") );
    DropBox->setAutoRepeat( FALSE );
    DropBox->setAutoResize( FALSE );

    ReloadBox = new QCheckBox( this, "ReloadBox" );
    ReloadBox->setGeometry( 80, 0, 80, 25 );
    ReloadBox->setMinimumSize( 10, 25 );
    ReloadBox->setMaximumSize( 32767, 25 );
    connect( ReloadBox, SIGNAL(toggled(bool)), SLOT(ReloadToggled(bool)) );
    ReloadBox->setText( i18n("Reload") );
    ReloadBox->setAutoRepeat( FALSE );
    ReloadBox->setAutoResize( FALSE );

    ShutdownBox = new QCheckBox( this, "ShutDownBox" );
    ShutdownBox->setGeometry( 160, 0, 80, 25 );
    ShutdownBox->setMinimumSize( 10, 25 );
    ShutdownBox->setMaximumSize( 32767, 25 );
    connect( ShutdownBox, SIGNAL(toggled(bool)), SLOT(ShutDownToggled(bool)) );
    ShutdownBox->setText( i18n("ShutDown") );
    ShutdownBox->setAutoRepeat( FALSE );
    ShutdownBox->setAutoResize( FALSE );

    ProcessBox = new QCheckBox( this, "ProcessBox" );
    ProcessBox->setGeometry( 240, 0, 80, 25 );
    ProcessBox->setMinimumSize( 10, 25 );
    ProcessBox->setMaximumSize( 32767, 25 );
    connect( ProcessBox, SIGNAL(toggled(bool)), SLOT(ProcessToggled(bool)) );
    ProcessBox->setText( i18n("Process") );
    ProcessBox->setAutoRepeat( FALSE );
    ProcessBox->setAutoResize( FALSE );

    FileBox = new QCheckBox( this, "FileBox" );
    FileBox->setGeometry( 320, 0, 80, 25 );
    FileBox->setMinimumSize( 10, 25 );
    FileBox->setMaximumSize( 32767, 25 );
    connect( FileBox, SIGNAL(toggled(bool)), SLOT(FileToggled(bool)) );
    FileBox->setText( i18n("File") );
    FileBox->setAutoRepeat( FALSE );
    FileBox->setAutoResize( FALSE );

    QBoxLayout* dlgedit_layout_1 = new QBoxLayout( this, QBoxLayout::TopToBottom, 5, 3, NULL );
    dlgedit_layout_1->addStrut( 0 );
    QBoxLayout* dlgedit_layout_1_1 = new QBoxLayout( QBoxLayout::TopToBottom, 5, "EditLinesLayout" );
    dlgedit_layout_1->addLayout( dlgedit_layout_1_1, 1 );
    dlgedit_layout_1_1->addStrut( 0 );
    EditLayout = dlgedit_layout_1_1;

    QBoxLayout* dlgedit_layout_1_2 = new QBoxLayout( QBoxLayout::TopToBottom, 0, "LowerLayout" );
    dlgedit_layout_1->addLayout( dlgedit_layout_1_2, 0 );
    dlgedit_layout_1_2->addStrut( 0 );
    QBoxLayout* dlgedit_layout_1_2_1 = new QBoxLayout( QBoxLayout::LeftToRight, 0, "ToggleBar1" );
    dlgedit_layout_1_2->addLayout( dlgedit_layout_1_2_1, 0 );
    dlgedit_layout_1_2_1->addStrut( 0 );
    dlgedit_layout_1_2_1->addWidget( SelectBox, 1, 36 );
    dlgedit_layout_1_2_1->addWidget( InsertBox, 1, 36 );
    dlgedit_layout_1_2_1->addWidget( UpdateBox, 1, 36 );
    dlgedit_layout_1_2_1->addWidget( DeleteBox, 1, 36 );
    dlgedit_layout_1_2_1->addWidget( CreateBox, 1, 36 );

    QBoxLayout* dlgedit_layout_1_2_2 = new QBoxLayout( QBoxLayout::LeftToRight, 0, "ToggleBar2" );
    dlgedit_layout_1_2->addLayout( dlgedit_layout_1_2_2, 0 );
    dlgedit_layout_1_2_2->addStrut( 0 );
    dlgedit_layout_1_2_2->addWidget( DropBox, 1, 36 );
    dlgedit_layout_1_2_2->addWidget( ReloadBox, 1, 36 );
    dlgedit_layout_1_2_2->addWidget( ShutdownBox, 1, 36 );
    dlgedit_layout_1_2_2->addWidget( ProcessBox, 1, 36 );
    dlgedit_layout_1_2_2->addWidget( FileBox, 1, 36 );

    QBoxLayout* dlgedit_layout_1_2_3 = new QBoxLayout( QBoxLayout::LeftToRight, 0, "Buttonbar" );
    dlgedit_layout_1_2->addLayout( dlgedit_layout_1_2_3, 0 );
    dlgedit_layout_1_2_3->addStrut( 0 );
    dlgedit_layout_1_2_3->addWidget( SaveButton, 1, 36 );
    dlgedit_layout_1_2_3->addWidget( ResetButton, 1, 36 );
    dlgedit_layout_1_2_3->addWidget( CloseButton, 1, 36 );



    resize( 410,280 );
    setMinimumSize( 0, 0 );
    setMaximumSize( 32767, 32767 );
}


CGrantEditData::~CGrantEditData()
{
}
void CGrantEditData::reset_values()
{
}
void CGrantEditData::SelectToggled(bool)
{
}
void CGrantEditData::InsertToggled(bool)
{
}
void CGrantEditData::UpdateToggled(bool)
{
}
void CGrantEditData::DeleteToggled(bool)
{
}
void CGrantEditData::CreateToggled(bool)
{
}
void CGrantEditData::ReloadToggled(bool)
{
}
void CGrantEditData::ShutDownToggled(bool)
{
}
void CGrantEditData::ProcessToggled(bool)
{
}
void CGrantEditData::FileToggled(bool)
{
}
